From f525f9422b4ce0acb224e2a04a93473f01edeaee Mon Sep 17 00:00:00 2001
From: Ilya Shpigor <shpigor@etersoft.ru>
Date: Fri, 23 Jan 2009 14:50:55 +0300
Subject: [PATCH] winex11.drv: Add checking to desktop for foreground window in can_activate_window hack (eterbug #3369 #2437)

---
 dlls/winex11.drv/event.c |    8 +++++---
 1 files changed, 5 insertions(+), 3 deletions(-)

diff --git a/dlls/winex11.drv/event.c b/dlls/winex11.drv/event.c
index 56e1135..ba8ec97 100644
--- a/dlls/winex11.drv/event.c
+++ b/dlls/winex11.drv/event.c
@@ -470,10 +470,12 @@ static inline BOOL can_activate_window( HWND hwnd )
     /* Don't activate main window 1c7 if there is the foreground popup */
     LOADETER_FUNC(etersoft_1version);
     if ( etersoft_1version && (etersoft_1version() == 7) )
-        if (!GetParent(hwnd) && GetForegroundWindow()
-            && (GetWindowLongW(GetForegroundWindow(), GWL_STYLE) & WS_POPUP))
+    {
+        HWND fg = GetForegroundWindow();
+        if (!GetParent(hwnd) && fg && (fg != GetDesktopWindow())
+            && (GetWindowLongW(fg, GWL_STYLE) & WS_POPUP))
             return FALSE;
-
+    }
     return TRUE;
 }
 
-- 
1.6.0.2.GIT

